diff --git app/controllers/download_svn_revision_controller.rb~ app/controllers/download_svn_revision_controller.rb~
new file mode 100644
index 0000000..1e2e7be
--- /dev/null
+++ app/controllers/download_svn_revision_controller.rb~
@@ -0,0 +1,80 @@
+class DownloadSvnRevisionController < ApplicationController
+  unloadable
+
+  before_filter :require_login
+  before_filter :set_repository_variable
+  before_filter :set_project_variable
+  #before_filter :can_download_svn_revision
+
+  #helper :git_hosting
+
+
+  def index
+    commit = nil
+    format = params[:download_format]
+
+    if !params[:rev]
+      rev = "master"
+    else
+      rev = params[:rev]
+    end
+
+
+    project_name = @repository.name.to_s.parameterize.to_s
+
+    cmd_args = ""
+
+    case format
+      when 'tar' then
+        extension = 'tar'
+        content_type = 'application/x-tar'
+        cmd_args << "tar -cvf #{project_name}-#{rev}.#{extension} #{project_name}-#{rev}"
+      when 'tar.gz' then
+        extension = 'tar.gz'
+        content_type = 'application/x-gzip'
+        cmd_args << "tar -zcvf #{project_name}-#{rev}.#{extension} #{project_name}-#{rev}"
+      when 'zip' then
+        extension = 'zip'
+        content_type = 'application/x-zip'
+        cmd_args << "zip -r #{project_name}-#{rev}.#{extension} #{project_name}-#{rev}"
+    end
+
+    #begin
+      #system("echo '#{@repository.url} #{project_name}-#{rev}.#{extension}' > log/logging.log")
+      system("svn export #{@repository.url} #{project_name}-#{rev}; #{cmd_args}")
+      content = "#{project_name}-#{rev}.#{extension}"
+    #rescue => e
+      #flash.now[:error] = l(:git_archive_timeout, :timeout => e.message)
+     # render_404
+      #return
+    #end
+    if(File.file?("#{project_name}-#{rev}.#{extension}"))
+      send_file(content, :filename => "#{project_name}-#{rev}.#{extension}", :type => content_type)
+    end
+ end
+
+
+  private
+
+
+  def can_download_svn_revision
+    render_403 unless view_context.user_allowed_to(:download_svn_revision, @project)
+  end
+
+
+  def set_repository_variable
+    @repository = Repository.find_by_id(params[:repository_id])
+    if @repository.nil?
+      render_404
+    end
+  end
+
+
+  def set_project_variable
+    @project = @repository.project
+    if @project.nil?
+      render_404
+    end
+  end
+
+end
diff --git app/views/repositories/_download_revision.erb app/views/repositories/_download_revision.erb
index a6b967b..3d45135 100644
--- app/views/repositories/_download_revision.erb
+++ app/views/repositories/_download_revision.erb
@@ -31,3 +31,40 @@
 
   <% end %>
 <% end %>
+
+
+<% if defined?(SCMCreator) == 'constant' && SCMCreator.class == Class %>
+ <% if @repository.is_a?(Repository::Subversion)%>
+  <% if (@project.active? && User.current.allowed_to?(:download_svn_revision, @project)) || (!@project.active? &&  User.current.allowed_to?(:download_svn_revision, nil, :global => true)) %>
+
+    <div style="clear: both;"></div>
+
+    <div id="svn_hosting_download_buttons">
+      <ul>
+        <li>
+          <%= link_to "<i class=\"fa fa-download\"></i>".html_safe + l(:label_download_format, :archive_format => '.tar'),
+                      download_svn_revision_path(@repository.id, :rev => @rev, :download_format => 'tar'),
+                      :class => 'button' %>
+        </li>
+
+        <li>
+          <%= link_to "<i class=\"fa fa-download\"></i>".html_safe + l(:label_download_format, :archive_format => '.tar.gz'),
+                      download_svn_revision_path(@repository.id, :rev => @rev, :download_format => 'tar.gz'),
+                      :class => 'button' %>
+        </li>
+
+        <li>
+          <%= link_to "<i class=\"fa fa-download\"></i>".html_safe + l(:label_download_format, :archive_format => '.zip'),
+                      download_svn_revision_path(@repository.id, :rev => @rev, :download_format => 'zip'),
+                      :class => 'button' %>
+        </li>
+      </ul>
+    </div>
+
+    <% content_for :header_tags do %>
+      <%= stylesheet_link_tag 'font_awesome', :plugin => 'redmine_git_hosting' %>
+    <% end %>
+
+  <% end %>
+ <% end %>
+<% end %>
\ No newline at end of file
diff --git app/views/repositories/stats.html.erb app/views/repositories/stats.html.erb
index f5656b9..7407c24 100644
--- app/views/repositories/stats.html.erb
+++ app/views/repositories/stats.html.erb
@@ -1,3 +1,27 @@
+<% if !(@repository.is_a? Repository::Git) %>
+<h2><%= l(:label_statistics) %></h2>
+
+<p>
+<%= tag("embed",
+        :type => "image/svg+xml", :src => url_for(:controller => 'repositories',
+        :action => 'graph', :id => @project,
+        :repository_id => @repository.identifier_param,
+        :graph => "commits_per_month")) %>
+</p>
+<p>
+<%= tag("embed",
+        :type => "image/svg+xml", :src => url_for(:controller => 'repositories',
+        :action => 'graph', :id => @project,
+        :repository_id => @repository.identifier_param,
+        :graph => "commits_per_author")) %>
+</p>
+
+<p><%= link_to l(:button_back), :action => 'show', :id => @project %></p>
+
+<% html_title(l(:label_repository), l(:label_statistics)) -%>
+
+<% else %>
+
 <h2><%= l(:label_statistics) %></h2>
 
 <% content_for :header_tags do %>
@@ -141,3 +165,5 @@
 <p><%= link_to l(:button_back), :action => 'show', :id => @project %></p>
 
 <% html_title(l(:label_repository), l(:label_statistics)) -%>
+
+<% end %>
diff --git lib/redmine_git_hosting/patches/repository_patch.rb lib/redmine_git_hosting/patches/repository_patch.rb
index 95e09a9..e63ef4e 100644
--- lib/redmine_git_hosting/patches/repository_patch.rb
+++ lib/redmine_git_hosting/patches/repository_patch.rb
@@ -33,25 +33,25 @@ module RedmineGitHosting
 
       module InstanceMethods
 
-        def global_statistics
-          total_commits = Changeset.where("repository_id = ?", self.id).count
-          first_commit  = Changeset.where("repository_id = ?", self.id).order('commit_date ASC').first
-          last_commit   = Changeset.where("repository_id = ?", self.id).order('commit_date ASC').last
-          active_for    = (last_commit.commit_date - first_commit.commit_date).to_i
-          committers    = Changeset.where("repository_id = ?", self.id).where("user_id IS NOT NULL").select(:user_id).uniq.count
-          committers   += Changeset.where("repository_id = ?", self.id).where(user_id: nil).select(:committer).uniq.count
-
-          data = {}
-          data[l(:label_total_commits)]               = total_commits
-          data[l(:label_total_contributors)]          = committers
-          data[l(:label_first_commit_date)]           = first_commit.commit_date
-          data[l(:label_latest_commit_date)]          = last_commit.commit_date
-          data[l(:label_active_for)]                  = "#{active_for} #{l(:label_active_days)}"
-          data[l(:label_average_commit_per_day)]      = total_commits.fdiv(active_for).round(2)
-          data[l(:label_average_contributor_commits)] = total_commits.fdiv(committers).round(2)
-
-          return data
-        end
+         def global_statistics
+           total_commits = Changeset.where("repository_id = ?", self.id).count
+           first_commit  = Changeset.where("repository_id = ?", self.id).order('commit_date ASC').first
+           last_commit   = Changeset.where("repository_id = ?", self.id).order('commit_date ASC').last
+           active_for    = (last_commit.commit_date - first_commit.commit_date).to_i
+           committers    = Changeset.where("repository_id = ?", self.id).where("user_id IS NOT NULL").select(:user_id).uniq.count
+           committers   += Changeset.where("repository_id = ?", self.id).where(user_id: nil).select(:committer).uniq.count
+
+           data = {}
+           data[l(:label_total_commits)]               = total_commits
+           data[l(:label_total_contributors)]          = committers
+           data[l(:label_first_commit_date)]           = first_commit.commit_date
+           data[l(:label_latest_commit_date)]          = last_commit.commit_date
+           data[l(:label_active_for)]                  = "#{active_for} #{l(:label_active_days)}"
+           data[l(:label_average_commit_per_day)]      = total_commits.fdiv(active_for).round(2)
+           data[l(:label_average_contributor_commits)] = total_commits.fdiv(committers).round(2)
+
+           return data
+         end
 
 
         def commits_per_hours